unit Unit1;

{$MODE objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Grids, mdbtools;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

uses glib2;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var mdb: PMdbHandle;
  entry: PMdbCatalogEntry;
  numcat, i: integer;
begin
  if OpenDialog1.Execute then
  begin
    mdb_init;
    try
      mdb := mdb_open(PChar(OpenDialog1.FileName), MDB_NOFLAGS);
      mdb_read_catalog(mdb, MDB_TABLE); //or MDB_ANY
      numcat := mdb^.num_catalog;
      ComboBox1.Clear;
      for i := 0 to numcat - 1 do
      begin
        entry := g_ptr_array_index(mdb^.catalog, i);
        if not mdb_is_system_table(entry) then
          ComboBox1.Items.Add(entry^.object_name);
      end;
      ComboBox1.ItemIndex := 0;
      mdb_close(mdb);
    finally
      mdb_exit;
    end;
  end;
end;

procedure TForm1.ComboBox1Select(Sender: TObject);
var mdb: PMdbHandle;
  table: PMdbTableDef;
  col: PMdbColumn;
  numcols: dword;
  i: integer;
  bound_values: PPChar;
  bound_lens: Pinteger;
begin
  if OpenDialog1.FileName = '' then exit;
  if ComboBox1.Items.Count = 0 then exit;

  mdb_init;
  try
    mdb := mdb_open(PChar(OpenDialog1.FileName), MDB_WRITABLE);
    try
      table := mdb_read_table_by_name(mdb, PChar(ComboBox1.Items[ComboBox1.ItemIndex]), MDB_TABLE);

      mdb_read_columns(table);
      mdb_rewind_table(table);
      numcols := table^.num_cols;

      bound_values := g_malloc(numcols * sizeof(PChar));
      bound_lens := g_malloc(numcols * sizeof(integer));
      for i := 0 to numcols - 1 do
      begin
        bound_values[i] := PChar(g_malloc0(MDB_BIND_SIZE));
        mdb_bind_column(table, i + 1, bound_values[i], @bound_lens[i]);
      end;

      StringGrid1.BeginUpdate;
      StringGrid1.RowCount := 1;
      StringGrid1.ColCount := numcols;

      for i := 0 to numcols - 1 do
      begin
        col := g_ptr_array_index(table^.columns, i);
        StringGrid1.Cells[i, 0] := col^.name;
      end;

      while mdb_fetch_row(table) do
      begin
        StringGrid1.RowCount := StringGrid1.RowCount + 1;
        for i := 0 to table^.num_cols - 1 do
        begin
          col := g_ptr_array_index(table^.columns, i);
          if ((col^.col_type = MDB_OLE) and ((i = 0) or (col^.cur_value_len > 0))) then
            mdb_ole_read(mdb, col, bound_values[i], MDB_BIND_SIZE);
          StringGrid1.Cells[i, StringGrid1.RowCount - 1] := AdjustLineBreaks(bound_values[i]);
        end;
      end;
      StringGrid1.EndUpdate;
      g_free(bound_values);
      g_free(bound_lens);

      mdb_free_tabledef(table);
    finally
      mdb_close(mdb);
    end;
  finally
    mdb_exit;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var LibPath: string;
begin
  LibPath := ExtractFilePath(Application.ExeName) + 'libmdb.so';
  Loadmdbtools(PChar(LibPath));
end;

initialization
{$I unit1.lrs}

end.
